<template>
    <div class="white-block" v-if="$store.getters.getStatus === 'ok'">
        <div class="padding">
            <h3 class="big-header" :class="[$style['big']]">В Новый год без долгов!<span>*</span></h3>

            <div class="success-block" v-if="$pdl.supplementary.amnesty2019 &&  [3].includes($pdl.supplementary.amnesty2019.status) && totalPaid">
                Вы внесли:
                <strong>
                    {{(totalPaid / 2)|currency}} ₽
                </strong><br>
                Сумма погашенной задолженности:
                <strong>
                {{totalPaid|currency}} ₽
                </strong>
            </div>

            <div class="warning-block" v-if="$pdl.supplementary.amnesty2019  && [2].includes($pdl.supplementary.amnesty2019.status)">
                <a data-action="amnesty2019-pay" @click="pay">Внесите</a> в общей сложности  <strong>{{totalDebt|currency}} ₽</strong>
                до <strong>{{$dayjs($pdl.supplementary.amnesty2019.payDateEnd).format('DD.MM.YYYY (HH:mm)')}}</strong>, чтобы не возобновилось начисление процентов и пеней на остаток задолженности!<br>
            </div>

            <div>
                <p><strong>С 3 по 28 декабря 2018 г. достаточно внести всего 50% от суммы просроченной
                    задолженности, и Webbankir закроет ваш долг полностью! Или оплатите хотя бы 10%, и мы удвоим этот
                    платеж и предложим вам беспроцентную рассрочку на 4 месяца.</strong></p>

                <p>Таким образом, любая сумма, внесенная вами в период с 3 по 28 декабря 2018 года, <strong>равная
                    или превышающая 10-процентный размер от общей задолженности</strong>, будет автоматически
                    умножена на 2. В период проведения акции, после выполнения условия оплаты не менее 10% от суммы
                    задолженности, вы можете осуществлять неограниченное количество платежей, и каждый платеж будет
                    удвоен Webbankir.</p>

                <p>Если 29 декабря 2018 года долг не будет погашен полностью, но выполнено условие минимальной
                    оплаты для участия в акции, то 1 января 2019 года вам будет предоставлен 4-месячный график
                    платежей остатка задолженности в рассрочку, где дата первого платежа – 30 января 2019 года. </p>
            </div>
            <transition name="fade">
                <div v-if="!$pdl.supplementary.amnesty2019">
                    <div class="range-slider" >
                        <div :class="['row upper-text', $style.rangeSlider__caption]">
                            <div class="columns four">
                                <div class="upper-header">Вы собираетесь внести:</div>
                                <div :class="$style.inputSumWrapper">
                                    <div class="manual-entry">
                                        <input type="text"
                                               v-model.number="amount"
                                               :placeholder="beginSum"
                                               v-mask="'#####'"
                                               @keyup="changeSum"
                                               @blur="checkAndChoiceSum"
                                               :class="['effect', $style.inputSum, {textred: isErr}]"
                                        >
                                        <span class="focus-border"></span>
                                    </div>
                                    <div :class="['big', {textred: isErr}]">₽</div>
                                </div>
                            </div>
                            <div class="columns four">
                                <div class="upper-header">Сумма к зачислению:</div>
                                <div class="big">{{sumIn|currency}} ₽</div>
                            </div>
                            <div class="columns four">
                                <div class="upper-header">Остаток долга:</div>
                                <div class="big">{{sumLeft|currency}} ₽</div>
                            </div>
                        </div>
                    </div>

                    <range-slider :min="minSum"
                                  :max="maxSum"
                                  :step="sumCounterStep"
                                  v-model="sum"
                                  ref="calcAmount"
                    ></range-slider>

                    <button :class="[
                        $style.repayLoanButton,
                        {
                            button_loading: $interface.buttonLoading,
                            disabledBlock: isAmnestyCreated || isSmsFormSuccess,
                        }
                    ]"
                            @click="repayLoan"
                            :disabled="$interface.buttonLoading"
                    >
                      Оплатить долг с выгодой
                    </button>
                </div>
            </transition>



            <transition name="fade">
                <SmsForm v-if="isAmnestyCreated && !isSmsFormSuccess"
                         ref="smsForm"
                         @success="isSmsFormSuccess = true"
                />
            </transition>
            <transition name="fade">
                <PaymentForm v-if="isSmsFormSuccess || ($pdl.supplementary.amnesty2019 &&  $pdl.supplementary.amnesty2019.status) >= 2" ref="paymentForm" @success="paymentSuccess"></PaymentForm>
            </transition>
            <p>
                Чтобы принять участие в акции «В Новый год без долгов»*, вам необходимо подписать Дополнительное соглашение и внести хотя бы один платеж, равный либо превышающий 10% от общей суммы задолженности.
            </p>

            <h3>Обратите внимание!</h3>

            <p>C момента подписания Дополнительного соглашения и оплаты 10% и более от общей суммы задолженности
                начисление процентов и пеней полностью прекращается. Если оплата не поступает своевременно в
                соответствии с графиком рассрочки, условие о беспроцентной рассрочке автоматически отменяется,
                начисление процентов и пеней на оставшуюся сумму задолженности возобновляется. В случае внесения
                платежа размером менее 10% от общей суммы задолженности, внесенная сумма не удваивается.</p>

            <p>*Не является публичной офертой. Подробные Условия акции см. в
                <a @click="agreement" data-action="display_agreement" v-if="$pdl.supplementary.amnesty2019 && $pdl.supplementary.amnesty2019.status === 2">Дополнительном соглашении.</a>
                <span v-else>Дополнительном соглашении.</span>

            </p>
        </div>
    </div>
</template>

<script>
    import {LOANS_UPDATE_CURRENT_PDL} from '@/store/mutation-types'
    import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
    import RangeSlider from '@/components/RangeSlider'
    import {errorProlongation} from '@/utils/error/prolongation'
    import SmsForm from './SmsForm'
    import PaymentForm from '@/components/Pay/Payment'
    import pdl from '@/mixins/pdl';

    export default {
        name: 'MainBlock',

        mixins: [
            ErrorHandleMixin,
            GetValidateClass,
            pdl
        ],

        components: {
            RangeSlider,
            SmsForm,
            PaymentForm
        },


        data() {
            return {
                sum: 0,
                amount: '',
                sumCounterStep: 500,
                smsCode: '',
                isSmsFormSuccess: false,
                condition: true,
                textForWarningBlock: 'Доп.соглашение сформировано, необходимо подписать до ',
                prolongationSmsCode: '',
                isRepayLoanMethodSuccess: false,
                isAmnestyCreated: false,
                agree: true,
                callBack: false,
                isErr: false,
              paymentDone: false
            }
        },

        computed: {
              totalPaid () {
                if (!this.$pdl.supplementary.amnesty2019) {
                  return 0;
                }
                return parseFloat(this.$pdl.supplementary.amnesty2019.totalSum) - parseFloat(this.$pdl.sumTotal);
              },
            amnesty2019() {
              return this.$pdl.isAmnesty2019
            },
            minSum() {
                return Math.ceil(this.$pdl.isAmnesty2019.amnesty_deposit_amount) + (this.$posServices ? Math.ceil(this.$posServices.sumTotal) : 0);
            },
            maxSum() {
                return Math.ceil(this.amnesty2019.total_sum / 2) + (this.$posServices ? parseFloat(this.$posServices.sumTotal) : 0);
            },
            beginSum() {
                this.amount = Number(this.sum)
                return this.sum
            },

            sumIn () {
               return parseFloat(this.sum - parseFloat(this.$posServices ? this.$posServices.sumTotal : 0)) * 2;
            },

            sumLeft () {
              return Math.max(parseFloat(this.amnesty2019.total_sum -  this.sumIn).toFixed(2), 0);
            },
            totalDebt () {
              let total = 0;
              if (this.$posServices) {
                total+= this.$posServices.sumTotal;
              }
              total += this.$pdl.supplementary.amnesty2019.depositAmount;

              return total;
            }
        },

        created() {
            this.sum = parseFloat(this.maxSum * .75).toFixed(2);

            if (this.$pdl.supplementary.amnesty2019) {
              switch (this.$pdl.supplementary.amnesty2019.status) {
                case 1:
                  this.isAmnestyCreated = true;
                  break;
                case 4:
                  this.isAmnestyCreated = true;
                  this.isSmsFormSuccess = true;
                  this.sum = this.maxSum;
                  break;
              }
            }
        },


        watch: {
          isSmsFormSuccess(state) {
            if (state) {
              this.$store.commit('SET_PAYMENT', {
                type: 'AMNESTY_2019',
                amount: this.sum
              });
              this.$nextTick(() => {
                this.$helpers.scroll(this.$refs.paymentForm.$el, 'Фокус на форму оплаты после подписания допника');
              })
            }
          }
        },

        methods: {
            paymentSuccess () {
              console.log('paymentSuccess')
                const where = {
                  pdl: true
                }
                if (this.$posServices) {
                  where.pos = true;
                }
                this.initUpdate(where);
                this.paymentDone = true;
                this.$toastr.success('Оплата произведена успешно. Дождитесь СМС о зачислении средств.', 'Успешно');
                this.$helpers.scroll(this.$el);

                this.$backend.log({
                  lk_stats: 'amnesty_2019',
                  action: 'pay',
                  user_id: this.$user.id,
                  pdl_id: this.$pdl.id
                });
            },

            async repayLoan() {
                this.$store.commit('BUTTON_LOADING', true);
                this.$backend.postData('supplementary/amnesty-2019/create')
                    .then(async (response) => {
                      this.$toastr.success(/*'Договор подписан. Дождитесь СМС о переводе.'*/'Доп.соглашение успешно создано. ', 'Успешно');
                      await this.$store.dispatch('GET_LOAN_PDL');
                      this.isAmnestyCreated = true;
                      this.$nextTick(() => {
                        this.$helpers.scroll(this.$refs.smsForm.$el);
                      });

                      this.$backend.log({
                        lk_stats: 'amnesty_2019',
                        action: 'create',
                        user_id: this.$user.id,
                        pdl_id: this.$pdl.id
                      });
                    })
                    .catch(error => {
                        this.$toastr.error('Ошибка создания доп.соглашения', 'Ошибка');
                        this.$backend.log({
                          lk_stats: 'amnesty_2019',
                          error: JSON.stringify(Array.isArray(error.errors) ? error.errors : error),
                          action: 'create',
                          user_id: this.$user.id,
                          pdl_id: this.$pdl.id
                        });
                    })
                    .finally(async() => {
                        this.$store.commit('BUTTON_LOADING', false);
                    });
            },

            changeSum () {
                const sum = Number(this.amount);
                console.log()
                if(sum > this.maxSum) {
                    this.amount = this.sum = this.maxSum
                } else {
                    this.sum = sum
                }
                const sumWithoutMin = this.sum - this.minSum;
                let percent = Math.round((sumWithoutMin < 0 ? 0 : sumWithoutMin) / (this.maxSum - this.minSum) * 100);

                if (this.$refs.calcAmount) {
                    this.$refs.calcAmount.$refs.pathway.style.width = `${percent}%`
                    this.$refs.calcAmount.$refs.circle.style.left = `${percent}%`
                }
                this.isErr = false
                if(this.sum <= this.minSum - 1) {
                    this.isErr = true
                }
                if (this.$refs.calcAmount) {
                    if (percent <= 0) {
                        this.$refs.calcAmount.$refs.pathway.style.width = '0%'
                        this.$refs.calcAmount.$refs.circle.style.left = '0%'
                    }
                    if (percent >= 101) {
                        this.$refs.calcAmount.$refs.pathway.style.width = '100%'
                        this.$refs.calcAmount.$refs.circle.style.left = '100%'
                        this.isErr = true
                    }
                }
            },

            checkAndChoiceSum () {
                if (this.amount < this.$calculate.sum_min) {
                    this.sum = this.amount = this.minSum;
                    this.isErr = false;
                }
                if (this.amount > this.$calculate.sum_max) {
                    this.sum = this.amount = this.$calculate.sum_max;
                    this.isErr = false;
                }
            },

            pay () {
              this.$store.commit('SET_PAYMENT', {
                type: 'AMNESTY_2019',
                amount: this.totalDebt
              });
              this.$helpers.scroll(this.$refs.paymentForm.$el)
            },

          agreement () {
                console.log('agreement');
          }

        }

    }
</script>


<style scoped lang="scss">
    a[data-action] {
        cursor: pointer;
    }
    .columns {
        flex-shrink: 1;
    }
    @media (max-width: 700px) {
        .range-slider .upper-text {
            display: block;
        }
        .range-slider .upper-text .columns {
            text-align: center;
            border-left: 1px solid rgba(227,227,227,1);
            border-right: 1px solid rgba(227,227,227,1);
            border-top: 1px solid rgba(227,227,227,1);
            padding: 10px 20px 5px 20px;
            &:last-child {
                border-bottom: 1px solid rgba(227,227,227,1);
                margin-bottom: 10px;
            }
        }
    }
</style>

<style lang="scss" module>
    .inputSumWrapper {
        display: flex;
        align-items: baseline;
        justify-content: flex-start;
        @media (max-width: 700px) {
            justify-content: center;
        }
        :global(.big) {
            margin-left: -28px;
            z-index: 1;
        }
    }
    .rangeSlider__caption {

    }
    .inputSum {
        max-width: 135px;
        padding-right: 3px;
        margin-bottom: 0;
    }
    .repayLoanButton {
        width: 100%;
    }
    .big {
        font-size: 25px !important;
        font-weight: 500;
        text-transform: none;
    }
</style>
